const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const shop_items = sequelize.define(
    'shop_items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

cost_doodlecoins: {
        type: DataTypes.INTEGER,
      
      

      },

active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  shop_items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity















    db.shop_items.hasMany(db.item_redemptions, {
      as: 'item_redemptions_shop_item',
      foreignKey: {
          name: 'shop_itemId',
      },
      constraints: false,
    });















//end loop





    db.shop_items.hasMany(db.file, {
      as: 'thumbnail_image',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.shop_items.getTableName(),
        belongsToColumn: 'thumbnail_image',
      },
    });


    db.shop_items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.shop_items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return shop_items;
};


